"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __values = (this && this.__values) || function(o) {
    var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
    if (m) return m.call(o);
    if (o && typeof o.length === "number") return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
    throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.main = void 0;
var Vector_1 = require("../container/Vector");
var Deque_1 = require("../container/Deque");
var StringUtil_1 = require("./internal/StringUtil");
var TimeWatch_1 = require("./internal/TimeWatch");
var random_1 = require("../algorithm/random");
var sorting_1 = require("../ranges/algorithm/sorting");
function watch(n) {
    var items = [];
    for (var i = 0; i < n; ++i)
        items.push((0, random_1.randint)(1, n));
    var v = new Vector_1.Vector(items);
    var d = new Deque_1.Deque(items);
    return [
        TimeWatch_1.TimeWatch.measure(function () { return items.sort(function (x, y) { return x - y; }); }),
        TimeWatch_1.TimeWatch.measure(function () { return (0, sorting_1.sort)(v); }),
        TimeWatch_1.TimeWatch.measure(function () { return (0, sorting_1.sort)(d); }),
    ];
}
function main() {
    return __awaiter(this, void 0, void 0, function () {
        var ret, _a, _b, n, line, _c, _d, time;
        var e_1, _e, e_2, _f;
        return __generator(this, function (_g) {
            ret = "## Sorts \n" +
                " N | Array | Vector | Deque \n" +
                "---|-------|--------|-------\n";
            try {
                for (_a = __values([1000, 10000, 100000]), _b = _a.next(); !_b.done; _b = _a.next()) {
                    n = _b.value;
                    line = StringUtil_1.StringUtil.numberFormat(n);
                    try {
                        for (_c = (e_2 = void 0, __values(watch(n))), _d = _c.next(); !_d.done; _d = _c.next()) {
                            time = _d.value;
                            line += " | ".concat(StringUtil_1.StringUtil.numberFormat(time));
                        }
                    }
                    catch (e_2_1) { e_2 = { error: e_2_1 }; }
                    finally {
                        try {
                            if (_d && !_d.done && (_f = _c.return)) _f.call(_c);
                        }
                        finally { if (e_2) throw e_2.error; }
                    }
                    ret += line + "\n";
                }
            }
            catch (e_1_1) { e_1 = { error: e_1_1 }; }
            finally {
                try {
                    if (_b && !_b.done && (_e = _a.return)) _e.call(_a);
                }
                finally { if (e_1) throw e_1.error; }
            }
            return [2 /*return*/, ret];
        });
    });
}
exports.main = main;
//# sourceMappingURL=sorts.js.map