"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.test_binary_searches = void 0;
var std = __importStar(require("../../index"));
function test_binary_searches() {
    _Test_binary_search_of_atom();
    _Test_binary_search_of_pair();
}
exports.test_binary_searches = test_binary_searches;
function _Test_binary_search_of_atom() {
    var v = new std.Vector();
    var s = new std.TreeMultiSet();
    //----
    // FILL VALUES
    //----
    // INSERT ELEMENTS
    for (var i = 0; i < 100; ++i) {
        var val = Math.random();
        v.push_back(val);
        s.insert(val);
    }
    // SORT VECTOR
    std.ranges.sort(v);
    //----
    // VALIDATE
    //----
    for (var i = 0; i < 10000; ++i) {
        var val = Math.random();
        var v_it = std.ranges.equal_range(v, val);
        var s_it = s.equal_range(val);
        // VALIDATE LOWER BOUND
        if (v_it.first.equals(v.end()) === true)
            if (s_it.first.equals(s.end()) === false)
                throw new Error("Bug on std.lower_bound() or Set.lower_bound(); someone is out bound but the other is not.");
            else
                continue;
        else if (v_it.first.value !== s_it.first.value)
            throw new Error("Bug on std.lower_bound() or Set.lower_bound(); different value.");
        // VALIDATE UPPER BOUND
        if (v_it.second.equals(v.end()) === true)
            if (s_it.second.equals(s.end()) === false)
                throw new Error("Bug on std.upper_bound() or Set.upper_bound(); someone is out bound but the other is not.");
            else
                continue;
        else if (v_it.second.value !== s_it.second.value)
            throw new Error("Bug on std.upper_bound() or Set.upper_bound(); different value.");
    }
}
function _Test_binary_search_of_pair() {
    var v = new std.Vector();
    var m = new std.TreeMultiMap();
    //----
    // FILL VALUES
    //----
    // INSERT ELEMENTS
    for (var i = 0; i < 100; ++i) {
        var pair = std.make_pair(Math.random(), 0);
        v.push_back(pair);
        m.insert(pair);
    }
    // SORT VECTOR
    std.ranges.sort(v, _Compare_numbers_pair);
    //----
    // VALIDATE
    //----
    for (var i = 0; i < 10000; ++i) {
        var pair = std.make_pair(Math.random(), 0);
        var v_it = std.ranges.equal_range(v, pair, _Compare_numbers_pair);
        var m_it = m.equal_range(pair.first);
        // VALIDATE LOWER BOUND
        if (v_it.first.equals(v.end()) === true)
            if (m_it.first.equals(m.end()) === false)
                throw new Error("Bug on std.lower_bound() or Set.lower_bound(); someone is out bound but the other is not.");
            else
                continue;
        else if (v_it.first.value.first !== m_it.first.first)
            throw new Error("Bug on std.lower_bound() or Set.lower_bound(); different value.");
        // VALIDATE UPPER BOUND
        if (v_it.second.equals(v.end()) === true)
            if (m_it.second.equals(m.end()) === false)
                throw new Error("Bug on std.upper_bound() or Set.upper_bound(); someone is out bound but the other is not.");
            else
                continue;
        else if (v_it.second.value.first !== m_it.second.first)
            throw new Error("Bug on std.upper_bound() or Set.upper_bound(); different value.");
    }
}
function _Compare_numbers_pair(x, y) {
    return x.first < y.first;
}
//# sourceMappingURL=test_binary_searches.js.map