"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.test_heaps = void 0;
var std = __importStar(require("../../index"));
var Generator_1 = require("../internal/Generator");
function test_heaps() {
    for (var i = 0; i < 100; ++i) {
        var elems = Generator_1.Generator.fill(new std.Vector(), 100);
        std.ranges.make_heap(elems);
        if (std.ranges.is_heap(elems) === false)
            throw new Error("Bug on std.push_heap() or std.is_heap()");
        std.ranges.sort_heap(elems);
        if (std.ranges.is_sorted(elems) === false)
            throw new Error("Bug on std.pop_heap()");
    }
    _Test_c_plus_plus();
    _Test_cpp_reference();
}
exports.test_heaps = test_heaps;
function _Test_c_plus_plus() {
    var v = new std.Vector([10, 20, 30, 5, 15]);
    std.ranges.make_heap(v);
    if (v.front() !== 30 || std.ranges.is_heap(v) === false)
        throw new Error("Bug on std.make_heap()");
    std.ranges.pop_heap(v);
    v.pop_back();
    if (v.front() !== 20)
        throw new Error("Bug on std.pop_heap()");
    v.push_back(99);
    std.ranges.push_heap(v);
    if (v.front() !== 99)
        throw new Error("Bug on std.push_heap()");
    std.ranges.sort_heap(v);
    if (std.ranges.is_sorted(v) === false)
        throw new Error("Bug on std.sort_heap()");
}
function _Test_cpp_reference() {
    var v = new std.Vector();
    v.push(3, 1, 4, 1, 5, 9);
    std.ranges.make_heap(v);
    if (std.ranges.equal(v, [9, 5, 4, 1, 1, 3]) === false)
        throw new Error("Bug on std.make_heap()");
    std.ranges.pop_heap(v);
    if (v.back() !== 9)
        throw new Error("Bug on std.pop_heap()");
    v.pop_back();
    if (std.ranges.equal(v, [5, 3, 4, 1, 1]) === false)
        throw new Error("Bug on std.pop_heap() & Vector.pop()");
}
//# sourceMappingURL=test_heaps.js.map