"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __values = (this && this.__values) || function(o) {
    var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
    if (m) return m.call(o);
    if (o && typeof o.length === "number") return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
    throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.test_iterations = void 0;
var std = __importStar(require("../../index"));
var SIZE = 1000;
var MID = 561;
function test_iterations() {
    _Test_for_of_iterations();
    _Test_union_of_iterations();
    _Test_equals();
    _Test_mismatch();
    _Test_count();
    _Test_lexicographical_compare();
}
exports.test_iterations = test_iterations;
function _Test_for_of_iterations() {
    var items = new std.Vector();
    items.assign(1000, 1.5);
    var sum = 0;
    var fn = function (val) {
        sum += val;
    };
    std.ranges.for_each(items, fn);
    std.for_each_n(items.begin(), items.size(), fn);
    if (sum !== 1.5 * 1000 * 2)
        throw new Error("Bug on std.for_each() or std.for_each_n()");
}
function _Test_union_of_iterations() {
    var items = new std.Vector([2, 3, 4]);
    var flags = new std.Vector([
        std.ranges.all_of(items, function (val) { return val > 1.0; }),
        std.ranges.any_of(items, function (val) { return val === 2.0; }),
        std.ranges.none_of(items, function (val) { return val !== Math.floor(val); }),
    ]);
    var ret = std.ranges.all_of(flags, function (val) { return val; });
    if (ret === false)
        throw new Error("Bug on one of them: all_of(), any_of() or none_of()");
}
function _Test_equals() {
    var v1 = new std.Vector();
    var v2 = new std.Vector();
    for (var i = 0; i < SIZE; ++i)
        v1.push_back(Math.random());
    v2.assign(v1.begin(), v1.end());
    for (var i = MID; i < SIZE; ++i)
        v2.set(i, v2.at(i) * 100.0);
    if (std.equal(v1.begin(), v1.begin().advance(MID), v2.begin()) === false)
        throw new Error("Bug on std.equal(); true -> false");
    else if (std.ranges.equal(v1, v2) === true)
        throw new Error("Bug on std.equal(); false -> true");
}
function _Test_lexicographical_compare() {
    var v1 = new std.Vector([1, 1, 2, 3]);
    var v2 = new std.Vector([1, 1, 3, 3]);
    if (std.lexicographical_compare(v1.begin(), v1.end(), v2.begin(), v2.end()) === false)
        throw new Error("Bug on std.lexicographical_compare()");
}
function _Test_mismatch() {
    var v1 = new std.Vector();
    var v2 = new std.Vector();
    for (var i = 0; i < SIZE; ++i)
        v1.push_back(Math.random());
    v2.assign(v1.begin(), v1.end());
    v2.set(MID, -90);
    var pair = std.mismatch(v1.begin(), v1.end(), v2.begin());
    if (pair.first.index() !== pair.second.index() ||
        pair.first.index() !== MID)
        throw new Error("Bug on std.mismatch()");
}
function _Test_count() {
    var e_1, _a;
    var v = new std.Vector();
    for (var i = 0; i < SIZE; ++i)
        v.push_back(Math.random());
    var fn = function (val) {
        return val >= 0.5;
    };
    var cnt = 0;
    try {
        for (var v_1 = __values(v), v_1_1 = v_1.next(); !v_1_1.done; v_1_1 = v_1.next()) {
            var val = v_1_1.value;
            if (fn(val) === true)
                ++cnt;
        }
    }
    catch (e_1_1) { e_1 = { error: e_1_1 }; }
    finally {
        try {
            if (v_1_1 && !v_1_1.done && (_a = v_1.return)) _a.call(v_1);
        }
        finally { if (e_1) throw e_1.error; }
    }
    if (std.count_if(v.begin(), v.end(), fn) !== cnt)
        throw new Error("Bug on std.count_if()");
}
//# sourceMappingURL=test_iterations.js.map