"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
var __values = (this && this.__values) || function(o) {
    var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
    if (m) return m.call(o);
    if (o && typeof o.length === "number") return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
    throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.test_merges = void 0;
var std = __importStar(require("../../index"));
var Generator_1 = require("../internal/Generator");
function test_merges() {
    _Test_merge();
    _Test_inplace_merge();
    _Test_includes();
    _Test_set_union();
    _Test_set_intersection();
    _Test_set_difference();
    _Test_set_symmetric_difference();
}
exports.test_merges = test_merges;
function _Test_merge() {
    var v1 = Generator_1.Generator.arrange(new std.Vector(), 100);
    var v2 = Generator_1.Generator.arrange(new std.Deque(), 50);
    var out = new std.List();
    std.ranges.merge(v1, v2, std.back_inserter(out));
    var solution = new std.TreeMultiSet(__spreadArray(__spreadArray([], __read(v1), false), __read(v2), false));
    if (std.ranges.equal(out, solution) === false)
        throw new Error("Bug on std.merge()");
}
function _Test_inplace_merge() {
    var v = Generator_1.Generator.fill(new std.Vector(), 400);
    var pos = v.nth(200);
    std.sort(v.begin(), pos);
    std.sort(pos, v.end());
    std.ranges.inplace_merge(v, pos);
    if (std.ranges.is_sorted(v) === false)
        throw new Error("Bug on std.inplace_merge()");
}
function _Test_includes() {
    var v1 = Generator_1.Generator.arrange(new std.Vector(), 100);
    var v2 = std.Vector.wrap(v1.data().slice(std.randint(10, 30), std.randint(10, 30)));
    if (std.ranges.includes(v1, v2) === false)
        throw new Error("Bug on std.includes()");
}
function _Test_set_union() {
    var v1 = Generator_1.Generator.fill(new std.TreeSet(), 200);
    var v2 = Generator_1.Generator.fill(new std.TreeSet(), 200);
    var out = new std.List();
    std.ranges.set_union(v1, v2, std.back_inserter(out));
    var solution = new std.TreeSet(__spreadArray(__spreadArray([], __read(v1), false), __read(v2), false));
    if (std.ranges.equal(out, solution) === false)
        throw new Error("Bug on std.set_union()");
}
function _Test_set_intersection() {
    var e_1, _a;
    var v1 = Generator_1.Generator.fill(new std.TreeSet(), 200);
    var v2 = Generator_1.Generator.fill(new std.TreeSet(), 200);
    var out = new std.Vector();
    std.ranges.set_intersection(v1, v2, std.back_inserter(out));
    var solution = new std.Deque();
    try {
        for (var v1_1 = __values(v1), v1_1_1 = v1_1.next(); !v1_1_1.done; v1_1_1 = v1_1.next()) {
            var elem = v1_1_1.value;
            if (v2.has(elem) === true)
                solution.push_back(elem);
        }
    }
    catch (e_1_1) { e_1 = { error: e_1_1 }; }
    finally {
        try {
            if (v1_1_1 && !v1_1_1.done && (_a = v1_1.return)) _a.call(v1_1);
        }
        finally { if (e_1) throw e_1.error; }
    }
    if (std.ranges.equal(out, solution) === false)
        throw new Error("Bug on std.set_intersection()");
}
function _Test_set_difference() {
    var e_2, _a;
    var v1 = Generator_1.Generator.fill(new std.TreeSet(), 200);
    var v2 = Generator_1.Generator.fill(new std.TreeSet(), 200);
    var out = new std.Deque();
    std.ranges.set_difference(v1, v2, std.back_inserter(out));
    var solution = new std.Vector();
    try {
        for (var v1_2 = __values(v1), v1_2_1 = v1_2.next(); !v1_2_1.done; v1_2_1 = v1_2.next()) {
            var elem = v1_2_1.value;
            if (v2.has(elem) === false)
                solution.push_back(elem);
        }
    }
    catch (e_2_1) { e_2 = { error: e_2_1 }; }
    finally {
        try {
            if (v1_2_1 && !v1_2_1.done && (_a = v1_2.return)) _a.call(v1_2);
        }
        finally { if (e_2) throw e_2.error; }
    }
    if (std.ranges.equal(out, solution) === false)
        throw new Error("Bug on std.set_difference()");
}
function _Test_set_symmetric_difference() {
    var e_3, _a, e_4, _b;
    var v1 = Generator_1.Generator.fill(new std.TreeSet(), 200);
    var v2 = Generator_1.Generator.fill(new std.TreeSet(), 200);
    var out = new std.List();
    std.ranges.set_symmetric_difference(v1, v2, std.back_inserter(out));
    var solution = new std.Deque();
    try {
        for (var v1_3 = __values(v1), v1_3_1 = v1_3.next(); !v1_3_1.done; v1_3_1 = v1_3.next()) {
            var elem = v1_3_1.value;
            if (v2.has(elem) === false)
                solution.push_back(elem);
        }
    }
    catch (e_3_1) { e_3 = { error: e_3_1 }; }
    finally {
        try {
            if (v1_3_1 && !v1_3_1.done && (_a = v1_3.return)) _a.call(v1_3);
        }
        finally { if (e_3) throw e_3.error; }
    }
    try {
        for (var v2_1 = __values(v2), v2_1_1 = v2_1.next(); !v2_1_1.done; v2_1_1 = v2_1.next()) {
            var elem = v2_1_1.value;
            if (v1.has(elem) === false)
                solution.push_back(elem);
        }
    }
    catch (e_4_1) { e_4 = { error: e_4_1 }; }
    finally {
        try {
            if (v2_1_1 && !v2_1_1.done && (_b = v2_1.return)) _b.call(v2_1);
        }
        finally { if (e_4) throw e_4.error; }
    }
    std.ranges.sort(solution);
    if (std.ranges.equal(out, solution) === false)
        throw new Error("Bug on std.set_symmetric_difference()");
}
//# sourceMappingURL=test_merges.js.map