"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.test_sortings = void 0;
var std = __importStar(require("../../index"));
var Cube_1 = require("../internal/Cube");
function test_sortings() {
    _Test_atomic_sorting();
    _Test_object_sorting();
}
exports.test_sortings = test_sortings;
function _Test_atomic_sorting() {
    var array = [];
    for (var i = 1; i <= 15; ++i)
        for (var j = 0; j < 3; ++j)
            array.push(i);
    std.ranges.shuffle(array);
    std.ranges.stable_sort(array);
    if (std.ranges.is_sorted(array) === false)
        throw new Error("Bug on std.stable_sort()");
}
function _Test_object_sorting() {
    //----
    // CONSTRUCT ITEMS
    //----
    var cubes = new std.Deque();
    for (var i = 0; i < 1000; ++i)
        cubes.push_back(new Cube_1.Cube());
    //----
    // SORT BY Cube.less
    //----
    // DO SORT
    std.ranges.sort(cubes);
    // VALIDATION
    if (std.ranges.is_sorted(cubes) === false)
        throw new Error("Bug on std.sort() with IComparable.less()");
    //----
    // SORT BY inline function
    //----
    // DECLARE INLINE FUNCTION
    var inline_function = function (cx, cy) {
        if (cx.x !== cy.x)
            return cx.x < cy.x;
        else if (cx.y !== cy.y)
            return cx.y < cy.y;
        else
            return cx.z < cy.z;
    };
    // DO SORT
    std.ranges.sort(cubes, inline_function);
    // VALIDATION
    if (std.ranges.is_sorted(cubes, inline_function) === false)
        throw new Error("Bug on std.sort() with parametric comparator");
}
//# sourceMappingURL=test_sortings.js.map