"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.test_adaptors = exports.test_priority_queue = void 0;
var std = __importStar(require("../../index"));
function test_priority_queue() {
    var adaptor = new std.PriorityQueue();
    var elements = [];
    for (var i = 0; i < 10; ++i)
        for (var j = 0; j < 4; ++j)
            adaptor.push(i);
    std.ranges.shuffle(elements);
    for (var i = 0; i < 10; ++i)
        adaptor.pop();
    while (elements.length !== 0) {
        var index = std.randint(0, elements.length - 1);
        var value = elements[index];
        adaptor.push(value);
        elements.splice(index, 1);
    }
    var previous = 1000;
    while (adaptor.empty() === false) {
        if (previous < adaptor.top())
            throw new Error("Bug on PriorityQueue: elements are not reversly sorted - " +
                previous.toString() +
                " < " +
                adaptor.top().toString());
        previous = adaptor.top();
        adaptor.pop();
    }
}
exports.test_priority_queue = test_priority_queue;
function test_adaptors() {
    // CONSTRUCT ADAPTOR CONATINERS
    var queue = _Construct_adaptor(new std.Queue());
    var stack = _Construct_adaptor(new std.Stack());
    // VALIDATE QUEUE
    var queue_items = [];
    while (queue.empty() === false) {
        queue_items.push(queue.front());
        queue.pop();
    }
    _Validate_adaptor_items(queue_items, [0, 1, 2, 3, 4]);
    // VALIDATE STACK
    var stack_items = [];
    while (stack.empty() === false) {
        stack_items.push(stack.top());
        stack.pop();
    }
    _Validate_adaptor_items(stack_items, queue_items.reverse());
}
exports.test_adaptors = test_adaptors;
function _Construct_adaptor(adaptor) {
    for (var i = 0; i < 5; ++i)
        adaptor.push(i);
    return adaptor;
}
function _Validate_adaptor_items(items, answer) {
    if (items.length !== answer.length)
        throw new std.DomainError("Number of elements are wrong.");
    for (var i = 0; i < items.length; ++i)
        if (items[i] !== answer[i])
            throw new std.DomainError("Wrong element is inserted in.");
}
//# sourceMappingURL=test_adaptors.js.map