"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __values = (this && this.__values) || function(o) {
    var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
    if (m) return m.call(o);
    if (o && typeof o.length === "number") return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
    throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.test_associatives = void 0;
var std = __importStar(require("../../index"));
var Atomic_1 = require("../internal/Atomic");
function test_associatives() {
    //----
    // SET-CONTAINERS
    //----
    // UNIQUE-SETS
    _Test_unique_set(new std.HashSet());
    _Test_unique_set(new std.TreeSet());
    _Test_unique_set(new std.experimental.FlatSet());
    // MULTI-SETS
    _Test_multi_set(new std.HashMultiSet());
    _Test_multi_set(new std.TreeMultiSet());
    _Test_multi_set(new std.experimental.FlatMultiSet());
    //----
    // MAP-CONTAINERS
    //----
    // UNIQUE-MAPS
    _Test_unique_map(new std.HashMap());
    _Test_unique_map(new std.TreeMap());
    _Test_unique_map(new std.experimental.FlatMap());
    // MULTI0-MAPS
    _Test_multi_map(new std.HashMultiMap());
    _Test_multi_map(new std.TreeMultiMap());
    _Test_multi_map(new std.experimental.FlatMultiMap());
}
exports.test_associatives = test_associatives;
/* ---------------------------------------------------------
    SET CONTAINERS
--------------------------------------------------------- */
function _Test_unique_set(set) {
    var e_1, _a;
    // CONSTRUCT ELEMENTS
    _Construct_set(set);
    // DUPLICATED ?
    if (set.size() !== 11)
        throw new Error("Bug on ".concat(set.constructor.name, ": wrong number of elements are stored."));
    var sum = 0;
    try {
        for (var set_1 = __values(set), set_1_1 = set_1.next(); !set_1_1.done; set_1_1 = set_1.next()) {
            var elem = set_1_1.value;
            // TO VALIDATE
            sum += elem.value;
            // RE-FIND THE ELEMENT BY ITS KEY WITH FIND() FUNCTION.
            var it = set.find(elem);
            if (it.equals(set.end()) === true)
                throw new Error("Bug on ".concat(set.constructor.name, ".find(): failed to find anything."));
            else if (it.value.equals(elem) === false)
                throw new Error("Bug on ".concat(set.constructor.name, ".find(): found wrong item."));
        }
    }
    catch (e_1_1) { e_1 = { error: e_1_1 }; }
    finally {
        try {
            if (set_1_1 && !set_1_1.done && (_a = set_1.return)) _a.call(set_1);
        }
        finally { if (e_1) throw e_1.error; }
    }
    // RE-VALIDATE UNIQUENESS & RIGHT INSERTION
    if (sum !== 55)
        throw new Error("Bug on ".concat(set.constructor.name, ": elements are not fully inserted."));
}
function _Test_multi_set(set) {
    var e_2, _a;
    // CONSTRUCT ELEMENTS
    _Construct_set(set);
    // DUPLICATED ?
    if (set.size() !== 3 * 11)
        throw new Error("Bug on ".concat(set.constructor.name, ": wrong number of elements are stored."));
    var sum = 0;
    try {
        for (var set_2 = __values(set), set_2_1 = set_2.next(); !set_2_1.done; set_2_1 = set_2.next()) {
            var elem = set_2_1.value;
            // TO VALIDATE
            sum += elem.value;
            // RE-FIND THE ELEMENT BY ITS KEY WITH FIND() & COUNT() FUNCTION.
            var it = set.find(elem);
            var count = set.count(elem);
            if (it.equals(set.end()) === true)
                throw new Error("Bug on ".concat(set.constructor.name, ": failed to find anything."));
            else if (it.value.equals(elem) === false)
                throw new Error("Bug on ".concat(set.constructor.name, ".find(): found wrong item."));
            else if (count !== 3)
                throw new Error("Bug on ".concat(set.constructor.name, ".count(): wrong number of duplicated items."));
        }
    }
    catch (e_2_1) { e_2 = { error: e_2_1 }; }
    finally {
        try {
            if (set_2_1 && !set_2_1.done && (_a = set_2.return)) _a.call(set_2);
        }
        finally { if (e_2) throw e_2.error; }
    }
    // RE-VALIDATE DUPLICATION & RIGHT INSERTION
    if (sum !== 3 * 55)
        throw new Error("Bug on ".concat(set.constructor.name, ": elements are not fully inserted."));
}
function _Construct_set(set) {
    // INSERT ELEMENTS
    for (var i = 0; i <= 10; ++i)
        for (var j = 0; j < 3; ++j)
            set.push(new Atomic_1.Atomic(i));
    // TEST SEQUENCE
    var vec = new std.Vector(set.begin(), set.end());
    if (std.is_sorted(vec.begin(), vec.end()) === false)
        throw new Error("Bug on ".concat(set.constructor.name, ": stored elements are not sorted."));
}
/* ---------------------------------------------------------
    MAP CONTAINERS
--------------------------------------------------------- */
function _Test_unique_map(map) {
    var e_3, _a;
    // CONSTRUCT ELEMENTS
    _Construct_map(map);
    // DUPLICATED ?
    if (map.size() !== 11)
        throw new Error("Bug on ".concat(map.constructor.name, ": wrong number of elements are stored."));
    var sum = 0;
    try {
        for (var map_1 = __values(map), map_1_1 = map_1.next(); !map_1_1.done; map_1_1 = map_1.next()) {
            var pair = map_1_1.value;
            // TO VALIDATE
            sum += pair.second;
            // RE-FIND THE ELEMENT BY ITS KEY WITH FIND() FUNCTION.
            var it = map.find(pair.first);
            if (it.equals(map.end()) === true)
                throw new Error("Bug on ".concat(map.constructor.name, ".find(): failed to find anything."));
            else if (it.first.equals(pair.first) === false)
                throw new Error("Bug on ".concat(map.constructor.name, ".find(): found wrong item."));
        }
    }
    catch (e_3_1) { e_3 = { error: e_3_1 }; }
    finally {
        try {
            if (map_1_1 && !map_1_1.done && (_a = map_1.return)) _a.call(map_1);
        }
        finally { if (e_3) throw e_3.error; }
    }
    // RE-VALIDATE UNIQUENESS & RIGHT INSERTION
    if (sum !== 55)
        throw new Error("Bug on ".concat(map.constructor.name, ": elements are not fully inserted."));
}
function _Test_multi_map(map) {
    var e_4, _a;
    // CONSTRUCT ELEMENTS
    _Construct_map(map);
    // DUPLICATED ?
    if (map.size() !== 3 * 11)
        throw new Error("Bug on ".concat(map.constructor.name, ": wrong number of elements are stored."));
    var sum = 0;
    try {
        for (var map_2 = __values(map), map_2_1 = map_2.next(); !map_2_1.done; map_2_1 = map_2.next()) {
            var pair = map_2_1.value;
            // TO VALIDATE
            sum += pair.second;
            // RE-FIND THE ELEMENT BY ITS KEY WITH FIND() & COUNT() FUNCTION.
            var it = map.find(pair.first);
            var count = map.count(pair.first);
            if (it.equals(map.end()) === true)
                throw new Error("Bug on ".concat(map.constructor.name, ".find(): failed to find anything."));
            else if (it.first.equals(pair.first) === false)
                throw new Error("Bug on ".concat(map.constructor.name, ".find(): found wrong item."));
            else if (count !== 3)
                throw new Error("Bug on ".concat(map.constructor.name, ".count(): wrong number of duplicated items."));
        }
    }
    catch (e_4_1) { e_4 = { error: e_4_1 }; }
    finally {
        try {
            if (map_2_1 && !map_2_1.done && (_a = map_2.return)) _a.call(map_2);
        }
        finally { if (e_4) throw e_4.error; }
    }
    // RE-VALIDATE UNIQUENESS & RIGHT INSERTION
    if (sum !== 3 * 55)
        throw new Error("Bug on ".concat(map.constructor.name, ": elements are not fully inserted."));
}
function _Construct_map(map) {
    for (var i = 0; i <= 10; ++i)
        for (var j = 0; j < 3; ++j) {
            var key = new Atomic_1.Atomic(NUMBER_NAMES[i]);
            var value = i;
            map.push(std.make_pair(key, value));
        }
}
var NUMBER_NAMES = [
    "Zero",
    "First",
    "Second",
    "Third",
    "Fourth",
    "Fifth",
    "Sixth",
    "Seventh",
    "Eighth",
    "Nineth",
    "Tenth",
];
//# sourceMappingURL=test_associatives.js.map