"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __values = (this && this.__values) || function(o) {
    var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
    if (m) return m.call(o);
    if (o && typeof o.length === "number") return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
    throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.test_for_of_iterations = void 0;
var std = __importStar(require("../../index"));
function test_for_of_iterations() {
    // LINEAR CONTAINERS
    _Test_for_of_iteration(new std.Vector());
    _Test_for_of_iteration(new std.Deque());
    _Test_for_of_iteration(new std.List());
    // ASSOCIATIVE CONTAINERS
    _Test_for_of_iteration(new std.TreeSet());
    _Test_for_of_map_iteration();
}
exports.test_for_of_iterations = test_for_of_iterations;
function _Test_for_of_iteration(vec) {
    var e_1, _a;
    //----
    // CONSTRUCTIONS
    //----
    // CONSTRUCT ITEMS TO VALIDATE
    var items = new std.Vector(10, 0);
    std.iota(std.begin(items), std.end(items), 0);
    // PUSH THEM ALL TO THE CONTAINER
    vec.assign(std.begin(items), std.end(items));
    //----
    // VALIDATION
    //----
    var i = 0;
    try {
        for (var vec_1 = __values(vec), vec_1_1 = vec_1.next(); !vec_1_1.done; vec_1_1 = vec_1.next()) {
            var elem = vec_1_1.value;
            if (elem !== items.at(i++))
                throw new Error("Bug on ".concat(vec.constructor.name, "[Symbol.iterator]()."));
        }
    }
    catch (e_1_1) { e_1 = { error: e_1_1 }; }
    finally {
        try {
            if (vec_1_1 && !vec_1_1.done && (_a = vec_1.return)) _a.call(vec_1);
        }
        finally { if (e_1) throw e_1.error; }
    }
}
function _Test_for_of_map_iteration() {
    var e_2, _a;
    //----
    // CONSTRUCTIONS
    //----
    // CONSTRUCT ITEMS TO VALIDATE
    var map = new std.TreeMap();
    var items = [];
    for (var i_1 = 0; i_1 < 10; ++i_1)
        items.push(std.make_pair(i_1, i_1));
    // PUSH THEM ALL TO THE CONTAINER
    map.push.apply(map, __spreadArray([], __read(items), false));
    //----
    // VALIDATION
    //----
    var i = 0;
    try {
        for (var map_1 = __values(map), map_1_1 = map_1.next(); !map_1_1.done; map_1_1 = map_1.next()) {
            var pair = map_1_1.value;
            if (std.equal_to(pair, items[i++]) === false)
                throw new Error("Bug on TreeMap[Symbol.iterator]().");
        }
    }
    catch (e_2_1) { e_2 = { error: e_2_1 }; }
    finally {
        try {
            if (map_1_1 && !map_1_1.done && (_a = map_1.return)) _a.call(map_1);
        }
        finally { if (e_2) throw e_2.error; }
    }
}
//# sourceMappingURL=test_for_of_iterations.js.map