"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.test_linear_containers = void 0;
var std = __importStar(require("../../index"));
function test_linear_containers() {
    _Test_linear(new std.Vector());
    _Test_linear(new std.Deque());
    _Test_linear(new std.List());
}
exports.test_linear_containers = test_linear_containers;
function _Test_linear(vec) {
    //----
    // CONSTRUCT ELEMENTS
    //----
    // 0 ~ 9
    vec.assign(10, 0);
    std.iota(vec.begin(), vec.end(), 0);
    //----
    // ELEMENTS I/O
    //----
    // ERASE AN ELEMENT
    var it = std.advance(vec.begin(), 3); // STEP TO 3
    it = vec.erase(it); // AND ERASE THE 3
    if (it.value !== 4)
        // MUST BE 4
        throw new Error("Bug on ".concat(vec.constructor.name, ": nth(3) must be 4, but ").concat(it.value));
    // INSERT AN ELEMENT
    it = std.advance(vec.begin(), 2);
    it = vec.insert(it, -1); // insert -1
    if (it.value !== -1)
        throw new Error("Bug on ".concat(vec.constructor.name, ".inser(): returned iterator is not exact, it must be -1 but ").concat(it.value));
    // ERASE RANGE
    it = std.advance(vec.begin(), 6);
    it = vec.erase(it, std.advance(it, 3)); // erase from 6 to 9
    if (it.value !== 9)
        throw Error("Bug on ".concat(vec.constructor.name, ".erase(): returned iterator is not exact, it must be 9 but ").concat(it.value));
    //----
    // FINAL VALIDATION
    //----
    _Validate_linear_elements(vec, [0, 1, -1, 2, 4, 5, 9]);
}
function _Validate_linear_elements(vec, answer) {
    if (vec.size() !== answer.length)
        throw new Error("Bug on ".concat(vec.constructor.name, ": number of stored elements are wrong, it must be ").concat(answer.length, " but ").concat(vec.size()));
    var i = 0;
    for (var it = vec.begin(); !it.equals(vec.end()); it = it.next())
        if (it.value !== answer[i++])
            throw new Error("Bug on ".concat(vec.constructor.name, ": number of stored elements are different: it must be ").concat(answer[i], " but ").concat(it.value));
}
//# sourceMappingURL=test_linears.js.map