"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.test_lists = void 0;
var std = __importStar(require("../../index"));
function test_lists() {
    _Test_removes();
    _Test_merges();
    _Test_forward_lists();
}
exports.test_lists = test_lists;
function _Test_removes() {
    var v = new std.Vector();
    for (var i = 0; i < 10; ++i)
        v.push_back(Math.random());
    _Test_remove(std.List, v);
    _Test_remove(std.ForwardList, v);
}
function _Test_remove(creator, v) {
    var l = new creator(v.begin(), v.end());
    l.remove_if(_Remove_if);
    l.reverse();
    v.erase(std.remove_if(v.begin(), v.end(), _Remove_if), v.end());
    if (std.equal(l.begin(), l.end(), v.rbegin()) === false)
        throw new Error("Bug on ".concat(creator.name, ".remove_if()"));
}
function _Remove_if(val) {
    return val < 0.5;
}
function _Test_merges() {
    //----
    // PRELIMINARIES
    //----
    // SAMPLE DATA
    var v1 = new std.Vector([1, 2, 3, 7, 8, 15, 16]);
    var v2 = new std.Vector([5, 6, 12, 13]);
    // ARE SHUFFLED
    std.shuffle(v1.begin(), v1.end());
    std.shuffle(v2.begin(), v2.end());
    // VALIDATOR; SORTED & MERGED BY TREE-SET
    var set = new std.TreeSet(v1.data());
    set.push.apply(set, __spreadArray([], __read(v2.data()), false));
    //----
    // VALIDATE
    //----
    _Test_merge(std.List, v1, v2, set);
    _Test_merge(std.ForwardList, v1, v2, set);
}
function _Test_merge(creator, v1, v2, set) {
    // CONSTRUCT LISTS
    var l1 = new creator(v1.data());
    var l2 = new creator(v2.data());
    // SORT THEM TO MERGE
    l1.sort();
    l2.sort();
    // DO MERGE
    l1.merge(l2);
    // VALIDATE
    if (std.equal(l1.begin(), l1.end(), set.begin()) === false)
        throw new Error("Bug on ".concat(creator.name, ".merge()."));
}
function _Test_forward_lists() {
    //----
    // CONSTRUCT ELEMENTS
    //----
    var fl = new std.ForwardList();
    for (var i = 9; i >= 0; --i)
        fl.push_front(i);
    //----
    // ELEMENTS I/O
    //----
    var it = std.advance(fl.before_begin(), 3); // STEP TO 2
    it = fl.erase_after(it); // AND ERASE 3 BY ERASE_AFTER()
    if (it.value !== 4)
        throw new Error("Bug on std.ForwardList.erase_after(); single deletion.");
    // INSERT AN ELEMENT
    it = std.advance(fl.before_begin(), 2);
    it = fl.insert_after(it, -1); // INSERT -1
    if (it.value !== -1)
        throw new Error("Bug on std.ForwardList.insert_after().");
    // ERASE RANGE
    it = std.advance(fl.before_begin(), 6);
    it = fl.erase_after(it, std.advance(it, 3 + 1));
    if (it.value !== 9)
        throw new Error("Bug on std.ForwardList.erase_after(); range deletion.");
    //----
    // FINAL VALIDATION
    //----
    var answer = new std.Vector([0, 1, -1, 2, 4, 5, 9]);
    if (std.equal(fl.begin(), fl.end(), answer.begin()) === false)
        throw new Error("Bug on std.ForwardList; store elements are wrong.");
}
//# sourceMappingURL=test_lists.js.map