"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __values = (this && this.__values) || function(o) {
    var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
    if (m) return m.call(o);
    if (o && typeof o.length === "number") return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
    throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.test_swaps = void 0;
var std = __importStar(require("../../index"));
function test_swaps() {
    //----
    // REGULAR CONTAINERS
    //----
    // LINEARS
    _Test_container_swap(new std.Vector(), new std.Vector());
    _Test_container_swap(new std.Deque(), new std.Deque());
    _Test_container_swap(new std.List(), new std.List());
    // SET CONTAINERS
    _Test_container_swap(new std.TreeSet(), new std.TreeSet());
    _Test_container_swap(new std.TreeMultiSet(), new std.TreeMultiSet());
    _Test_container_swap(new std.HashSet(), new std.HashSet());
    _Test_container_swap(new std.HashMultiSet(), new std.HashMultiSet());
    // MAP CONTAINERS
    _Test_container_swap(new std.TreeMap(), new std.TreeMap());
    _Test_container_swap(new std.TreeMultiMap(), new std.TreeMultiMap());
    _Test_container_swap(new std.HashMap(), new std.HashMap());
    _Test_container_swap(new std.HashMultiMap(), new std.HashMultiMap());
    //----
    // SPECIAL CONTAINERS
    //----
    _Test_vector_bool_swap();
    _Test_forward_list_swap();
}
exports.test_swaps = test_swaps;
/* ---------------------------------------------------------
    REGULAR CONTAINERS
--------------------------------------------------------- */
function _Test_container_swap(v1, v2) {
    var e_1, _a;
    // INSERT ITEMS ON EACH CONTAINERS
    for (var i = 1; i <= 3; ++i) {
        v1.push(std.make_pair(i, i));
        v2.push(std.make_pair(i + 3, i + 3));
    }
    // SWAP THEM
    v1.swap(v2);
    // VALIDATE CONTENTS
    var sum = 0;
    try {
        for (var v1_1 = __values(v1), v1_1_1 = v1_1.next(); !v1_1_1.done; v1_1_1 = v1_1.next()) {
            var pair = v1_1_1.value;
            sum += pair.first;
        }
    }
    catch (e_1_1) { e_1 = { error: e_1_1 }; }
    finally {
        try {
            if (v1_1_1 && !v1_1_1.done && (_a = v1_1.return)) _a.call(v1_1);
        }
        finally { if (e_1) throw e_1.error; }
    }
    if (sum !== 4 + 5 + 6)
        throw new Error("Bug on ".concat(v1.constructor.name, ".swap(); contents."));
    else if (v1.begin().source() !== v1)
        throw new Error("Bug on ".concat(v1.constructor.name, ".swap(); source."));
    // VALIDATE NEW ITEMS
    v1.push(std.make_pair(7, 7));
    if (v1.end().prev().source() !== v1)
        throw new Error("Bug on ".concat(v1.constructor.name, ".swap(); source of newly inserted item."));
    // VALIDATE ITERATORS' SOURCE
    _Validate_iterators_source(v1);
    _Validate_iterators_source(v2);
    // SPECIAL VALIDATION -> SET OR MAP
    if (v1 instanceof std.base.SetContainer &&
        v2 instanceof std.base.SetContainer) {
        if (v1.find(std.make_pair(5, 5)).source() !== v1 ||
            v2.find(std.make_pair(2, 2)).source() !== v2)
            throw new Error("Bug on ".concat(v1.constructor.name, ".swap(); Invalid key-source mapping."));
    }
    else if (v1 instanceof std.base.MapContainer &&
        v2 instanceof std.base.MapContainer) {
        if (v1.find(4).source() !== v1 || v2.find(1).source() !== v2)
            throw new Error("Bug on ".concat(v1.constructor.name, ".swap(); Invalid key-source mapping."));
    }
}
function _Validate_iterators_source(container) {
    for (var it = container.begin(); !it.equals(container.end()); it = it.next())
        if (it.source() !== container)
            throw new std.DomainError("Bug on ".concat(container.constructor.name, ".swap(); reversable-iterator's source."));
    for (var it = container.rbegin(); !it.equals(container.rend()); it = it.next())
        if (it.source() !== container)
            throw new std.DomainError("Bug on ".concat(container.constructor.name, ".swap(); reverse-iterator's source."));
}
/* ---------------------------------------------------------
    SPECIAL CONTAINERS
--------------------------------------------------------- */
function _Test_vector_bool_swap() {
    var refer = new std.VectorBoolean();
    for (var i = 0; i < 100; ++i)
        refer.push_back(Math.random() < 0.5 ? false : true);
    var x = new std.VectorBoolean(refer);
    var y = new std.VectorBoolean(refer);
    y.flip(); // {y} = {!x}
    x.swap(y);
    if (std.equal(refer.begin(), refer.end(), y.begin()) === false)
        throw new Error("Bug on ".concat(x.constructor.name, ".swap(); contents."));
    _Validate_iterators_source(x);
    _Validate_iterators_source(y);
}
function _Test_forward_list_swap() {
    var x = new std.ForwardList();
    var y = new std.ForwardList();
    for (var i = 1; i <= 3; ++i) {
        x.push_front(i);
        y.push_front(i + 3);
    }
    x.swap(y);
    var sum = 0;
    for (var it = x.begin(); !it.equals(x.end()); it = it.next())
        sum += it.value;
    if (sum !== 4 + 5 + 6)
        throw new Error("Bug on ".concat(x.constructor.name, ".swap(); contents -> ").concat(sum));
    _Validate_forward_list_iterator_source(x);
    _Validate_forward_list_iterator_source(y);
}
function _Validate_forward_list_iterator_source(source) {
    for (var it = source.before_begin(); !it.equals(source.end()); it = it.next())
        if (it.source() !== source)
            throw new Error("Bug on ".concat(source.constructor.name, ".swap(); source."));
}
//# sourceMappingURL=test_swaps.js.map