"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __values = (this && this.__values) || function(o) {
    var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
    if (m) return m.call(o);
    if (o && typeof o.length === "number") return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
    throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.test_trees = void 0;
var std = __importStar(require("../../index"));
function test_trees() {
    _Test_tree_set(new std.TreeSet());
    _Test_tree_set(new std.experimental.FlatSet());
    _Test_tree_set(new std.TreeMultiSet());
    _Test_tree_set(new std.experimental.FlatMultiSet());
    _Test_tree_map(new std.TreeMap());
    _Test_tree_map(new std.experimental.FlatMap());
    _Test_tree_map(new std.TreeMultiMap());
    _Test_tree_map(new std.experimental.FlatMultiMap());
    _Test_tree_set_inserts_and_erases();
}
exports.test_trees = test_trees;
function _Test_tree_set_inserts_and_erases() {
    var e_1, _a;
    for (var k = 0; k < 100; ++k) {
        var set = new std.TreeSet();
        for (var i = 0; i < 100; ++i)
            set.insert(std.randint(0, 10000));
        try {
            for (var set_1 = (e_1 = void 0, __values(set)), set_1_1 = set_1.next(); !set_1_1.done; set_1_1 = set_1.next()) {
                var val = set_1_1.value;
                if (set.has(val) === false)
                    throw new Error("Bug on ".concat(set.constructor.name, ".has(): failed to detect stored element."));
            }
        }
        catch (e_1_1) { e_1 = { error: e_1_1 }; }
        finally {
            try {
                if (set_1_1 && !set_1_1.done && (_a = set_1.return)) _a.call(set_1);
            }
            finally { if (e_1) throw e_1.error; }
        }
        while (!set.empty()) {
            var advance = std.randint(0, set.size() - 1);
            var it = std.advance(set.begin(), advance);
            set.erase(it);
            if (set.has(it.value))
                throw new Error("Bug on ".concat(set.constructor.name, ".has(): detected deleted element."));
        }
    }
}
function _Test_tree_set(set) {
    for (var i = 0; i < 1000; ++i)
        set.push(Math.floor(Math.random() * 100));
    // VALIDATE SORTING
    if (std.ranges.is_sorted(set) === false)
        throw new Error("Bug on ".concat(set.constructor.name, ": stored elements are not sorted."));
    // VALIDATE FIND
    for (var i = 0; i < 100; ++i) {
        var val = Math.floor(Math.random() * 100);
        var alg_it = std.ranges.find(set, val);
        var set_it = set.find(val);
        if (alg_it === set.end())
            if (set_it === set.end())
                continue;
            else
                throw new Error("Bug on ".concat(set.constructor.name, ".find(): failed find anything."));
        else if (alg_it.value !== set_it.value)
            throw new Error("Bug on ".concat(set.constructor.name, ".find(): found wrong element."));
    }
}
function _Test_tree_map(map) {
    for (var i = 0; i < 1000; ++i)
        map.push(std.make_pair(Math.floor(Math.random() * 100), 0));
    // VALIDATE SORTING
    if (std.ranges.is_sorted(map) === false)
        throw new Error("Bug on ".concat(map.constructor.name, ": stored elements are not sorted."));
    var _loop_1 = function (i) {
        var val = Math.floor(Math.random() * 100);
        var alg_it = std.ranges.find_if(map, function (entry) { return val === entry.first; });
        var set_it = map.find(val);
        if (alg_it === map.end())
            if (set_it === map.end())
                return "continue";
            else
                throw new Error("Bug on ".concat(map.constructor.name, ".find(): failed find anything."));
        else if (alg_it.first !== set_it.first)
            throw new Error("Bug on ".concat(map.constructor.name, ".find(): found wrong element."));
    };
    // VALIDATE FIND
    for (var i = 0; i < 100; ++i) {
        _loop_1(i);
    }
}
//# sourceMappingURL=test_trees.js.map