"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __values = (this && this.__values) || function(o) {
    var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
    if (m) return m.call(o);
    if (o && typeof o.length === "number") return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
    throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.test_vector_bools = exports.rand_bool = void 0;
var std = __importStar(require("../../index"));
function rand_bool() {
    return Math.random() < 0.5 ? false : true;
}
exports.rand_bool = rand_bool;
function test_vector_bools() {
    _Test_vector_bool_elements_io();
    _Test_vector_bool_flip();
}
exports.test_vector_bools = test_vector_bools;
/* ---------------------------------------------------------
    ELEMENTS I/O
--------------------------------------------------------- */
function _Test_vector_bool_elements_io() {
    var v = new std.Vector();
    var d = new std.Deque();
    var l = new std.List();
    var vb = new std.VectorBoolean();
    //----
    // PARTIAL TESTS
    //----
    // INITIALIZE WITH 10 FALSES
    _Modify_bool_containers(vb, v, d, l, function (obj) {
        obj.assign(10, false);
    });
    var _loop_1 = function (i) {
        var pos = std.randint(0, v.size());
        var size = std.randint(1, 10);
        var value = rand_bool();
        _Modify_bool_containers(vb, v, d, l, function (obj) {
            obj.insert(std.advance(obj.begin(), pos), size, value);
        });
        _Validate_bool_containers(vb, v, d, l);
    };
    // REPEAT INSERTIONS
    for (var i = 0; i < 100; ++i) {
        _loop_1(i);
    }
    var _loop_2 = function (i) {
        var first = std.randint(0, v.size() - 1);
        var last = std.randint(first + 1, v.size());
        _Modify_bool_containers(vb, v, d, l, function (obj) {
            obj.erase(std.advance(obj.begin(), first), std.advance(obj.begin(), last));
        });
        _Validate_bool_containers(vb, v, d, l);
    };
    // REPEAT DELETIONS
    for (var i = 0; i < 100; ++i) {
        _loop_2(i);
    }
    //----
    // REPEATED INSERTIONS & DELETIONS KEEPING SIZE
    //----
    // ASSIGN 10 FLAGS
    var initial_value = rand_bool();
    _Modify_bool_containers(vb, v, d, l, function (obj) {
        obj.assign(100, initial_value);
    });
    var _loop_3 = function (i) {
        var index = std.randint(0, 99);
        var value = rand_bool();
        _Modify_bool_containers(vb, v, d, l, function (obj) {
            std.advance(obj.begin(), index).value = value;
        });
        _Validate_bool_containers(vb, v, d, l);
    };
    // CHANGE VALUES RANDOMLY
    for (var i = 0; i < 100; ++i) {
        _loop_3(i);
    }
    var _loop_4 = function (i) {
        // ERASE ELEMENTS
        var first_index = std.randint(0, v.size() - 1);
        var last_index = std.randint(first_index + 1, v.size());
        if (v.empty() || first_index >= last_index)
            return "continue";
        _Modify_bool_containers(vb, v, d, l, function (obj) {
            obj.erase(std.advance(obj.begin(), first_index), std.advance(obj.begin(), last_index));
        });
        // INSERT ELEMENTS
        var index = std.randint(0, v.size());
        var size = last_index - first_index;
        var value = rand_bool();
        _Modify_bool_containers(vb, v, d, l, function (obj) {
            obj.insert(std.advance(obj.begin(), index), size, value);
        });
        _Validate_bool_containers(vb, v, d, l);
    };
    // MASS DELETIONS AND INSERTIONS KEEPING SIZE
    for (var i = 0; i < 100; ++i) {
        _loop_4(i);
    }
}
function _Validate_bool_containers(vb, v, d, l) {
    var e_1, _a;
    try {
        for (var _b = __values([v, d, l]), _c = _b.next(); !_c.done; _c = _b.next()) {
            var container = _c.value;
            if (vb.size() !== container.size() ||
                std.equal(vb.begin(), vb.end(), container.begin()) === false)
                throw new Error("Bug on ".concat(vb.constructor.name, ": different elements are stored with ").concat(container.constructor.name));
        }
    }
    catch (e_1_1) { e_1 = { error: e_1_1 }; }
    finally {
        try {
            if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
        }
        finally { if (e_1) throw e_1.error; }
    }
}
function _Modify_bool_containers(vb, v, d, l, func) {
    func(v);
    func(d);
    func(l);
    func(vb);
}
/* ---------------------------------------------------------
    FLIP
--------------------------------------------------------- */
function _Test_vector_bool_flip() {
    var vb = new std.VectorBoolean();
    for (var i = 0; i < 100; ++i)
        vb.push_back(rand_bool());
    var cpy = new std.VectorBoolean(vb);
    cpy.flip();
    var valid = std.equal(vb.begin(), vb.end(), cpy.begin(), std.not_equal_to);
    if (valid === false)
        throw new std.DomainError("Bug on std.".concat(vb.constructor.name, ".flip()."));
}
//# sourceMappingURL=test_vector_bools.js.map