"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Generator = void 0;
var random_1 = require("../../algorithm/random");
var sorting_1 = require("../../algorithm/sorting");
var Generator;
(function (Generator) {
    function arrange(container, count, gen) {
        fill(container, count, gen);
        (0, sorting_1.sort)(container.begin(), container.end());
        return container;
    }
    Generator.arrange = arrange;
    function fill(container, count, gen) {
        if (gen === undefined)
            gen = function () { return (0, random_1.randint)(1, count * 2); };
        while (count-- > 0)
            container.push(gen());
        return container;
    }
    Generator.fill = fill;
})(Generator || (exports.Generator = Generator = {}));
//# sourceMappingURL=Generator.js.map