"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __values = (this && this.__values) || function(o) {
    var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
    if (m) return m.call(o);
    if (o && typeof o.length === "number") return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
    throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.test_numeric_algorithms = void 0;
var std = __importStar(require("../../index"));
var Point2D_1 = require("../internal/Point2D");
function test_numeric_algorithms() {
    //----
    // CONSTRUCT BASIC DATA
    //----
    var x = new std.Vector();
    var y = new std.Vector();
    for (var i = 0; i < 10; ++i) {
        x.push_back(new Point2D_1.Point2D(std.randint(0, 100), std.randint(0, 100)));
        y.push_back(new Point2D_1.Point2D(std.randint(0, 100), std.randint(0, 100)));
    }
    //----
    // DO TEST
    //----
    // COMMON ALGORITHMS
    _Test_accumulate(x);
    _Test_inner_product(x, y);
    _Test_adjacent_difference(x);
    _Test_partial_sum(x);
    // PREFIX SUMS
    _Test_inclusive_scan(x);
    _Test_exclusive_scan(x);
}
exports.test_numeric_algorithms = test_numeric_algorithms;
/* ---------------------------------------------------------
    COMMON ALGORITHMS
--------------------------------------------------------- */
function _Test_accumulate(vec) {
    var e_1, _a;
    var solution = new Point2D_1.Point2D();
    try {
        for (var vec_1 = __values(vec), vec_1_1 = vec_1.next(); !vec_1_1.done; vec_1_1 = vec_1.next()) {
            var elem = vec_1_1.value;
            solution = std.plus(solution, elem);
        }
    }
    catch (e_1_1) { e_1 = { error: e_1_1 }; }
    finally {
        try {
            if (vec_1_1 && !vec_1_1.done && (_a = vec_1.return)) _a.call(vec_1);
        }
        finally { if (e_1) throw e_1.error; }
    }
    var ret = std.accumulate(vec.begin(), vec.end(), new Point2D_1.Point2D());
    if (!std.equal_to(solution, ret))
        throw new std.DomainError("Bug on std.accumulate().");
}
function _Test_inner_product(x, y) {
    var solution = new Point2D_1.Point2D();
    for (var i = 0; i < x.size(); ++i)
        solution = std.plus(solution, std.multiplies(x.at(i), y.at(i)));
    var ret = std.inner_product(x.begin(), x.end(), y.begin(), new Point2D_1.Point2D());
    if (!std.equal_to(solution, ret))
        throw new std.DomainError("Bug on std.inner_product().");
}
function _Test_adjacent_difference(vec) {
    var solution = new std.Vector([vec.front()]);
    for (var i = 1; i < vec.size(); ++i)
        solution.push_back(std.minus(vec.at(i), vec.at(i - 1)));
    var ret = new std.Vector();
    std.adjacent_difference(vec.begin(), vec.end(), std.back_inserter(ret));
    if (std.equal(solution.begin(), solution.end(), ret.begin()) === false)
        throw new std.DomainError("Bug on std.adjacent_difference().");
}
function _Test_partial_sum(vec) {
    var e_2, _a;
    var solution = new std.Vector();
    var sum = new Point2D_1.Point2D();
    try {
        for (var vec_2 = __values(vec), vec_2_1 = vec_2.next(); !vec_2_1.done; vec_2_1 = vec_2.next()) {
            var elem = vec_2_1.value;
            sum = std.plus(sum, elem);
            solution.push_back(sum);
        }
    }
    catch (e_2_1) { e_2 = { error: e_2_1 }; }
    finally {
        try {
            if (vec_2_1 && !vec_2_1.done && (_a = vec_2.return)) _a.call(vec_2);
        }
        finally { if (e_2) throw e_2.error; }
    }
    var ret = new std.Vector();
    std.partial_sum(vec.begin(), vec.end(), std.back_inserter(ret));
    if (std.equal(solution.begin(), solution.end(), ret.begin()) === false)
        throw new std.DomainError("Bug on std.partial_sum().");
}
/* ---------------------------------------------------------
    PREFIX SUMS
--------------------------------------------------------- */
function _Test_inclusive_scan(vec) {
    var solution = new std.Vector([vec.front()]);
    for (var i = 1; i < vec.size(); ++i)
        solution.push_back(std.plus(vec.at(i), solution.at(i - 1)));
    var ret = new std.Vector();
    std.inclusive_scan(vec.begin(), vec.end(), std.back_inserter(ret));
    if (std.equal(solution.begin(), solution.end(), ret.begin()) === false)
        throw new std.DomainError("Bug on std.transform_inclusive_scan().");
}
function _Test_exclusive_scan(vec) {
    var solution = new std.Vector([new Point2D_1.Point2D()]);
    for (var i = 0; i < vec.size() - 1; ++i)
        solution.push(std.plus(vec.at(i), solution.at(i)));
    var ret = new std.Vector();
    std.exclusive_scan(vec.begin(), vec.end(), std.back_inserter(ret), new Point2D_1.Point2D());
    if (std.equal(solution.begin(), solution.end(), ret.begin()) === false)
        throw new std.DomainError("Bug on std.exclusive_scan().");
}
//# sourceMappingURL=test_numeric_algorithms.js.map