"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __values = (this && this.__values) || function(o) {
    var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
    if (m) return m.call(o);
    if (o && typeof o.length === "number") return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
    throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.test_special_maths = exports.similar = void 0;
var fs = __importStar(require("fs"));
var std = __importStar(require("../../index"));
var PATH = __filename.substr(-2) === "ts"
    ? "".concat(__dirname, "/special_math")
    : "".concat(__dirname, "/special_math").replace("lib", "src");
function similar(x, y, precision) {
    if (precision === void 0) { precision = 0.05; }
    var diff = _Difference(x, y);
    return diff < precision;
}
exports.similar = similar;
function test_special_maths() {
    var e_1, _a, e_2, _b;
    var content = fs
        .readFileSync(PATH + "/data.json")
        .toString("utf8");
    var solutions = JSON.parse(content);
    // TRACING ERRORS
    var aggregates = new std.HashMap();
    var output = "";
    try {
        for (var solutions_1 = __values(solutions), solutions_1_1 = solutions_1.next(); !solutions_1_1.done; solutions_1_1 = solutions_1.next()) {
            var solve = solutions_1_1.value;
            var name_1 = solve[0];
            var func = std[name_1];
            var args = solve.slice(1, solve.length - 1);
            var ret = func.apply(void 0, __spreadArray([], __read(args), false));
            var answer = solve[solve.length - 1];
            var difference = _Difference(answer, ret);
            if (isNaN(difference))
                difference = 1.0;
            if (!similar(ret, answer, 0.1)) {
                var it = aggregates.find(name_1);
                if (it.equals(aggregates.end()) === true)
                    it = aggregates.emplace(name_1, 0).first;
                ++it.second;
                output += "std.".concat(name_1, "(").concat(args.toString(), ") = ").concat(answer, " && ").concat(ret, " -> ").concat(difference, "\n");
            }
        }
    }
    catch (e_1_1) { e_1 = { error: e_1_1 }; }
    finally {
        try {
            if (solutions_1_1 && !solutions_1_1.done && (_a = solutions_1.return)) _a.call(solutions_1);
        }
        finally { if (e_1) throw e_1.error; }
    }
    if (aggregates.empty() === false)
        fs.writeFileSync(PATH + "errors.log", output, "utf8");
    var validate = true;
    try {
        for (var aggregates_1 = __values(aggregates), aggregates_1_1 = aggregates_1.next(); !aggregates_1_1.done; aggregates_1_1 = aggregates_1.next()) {
            var entry = aggregates_1_1.value;
            if (entry.second > 5)
                validate = false;
        }
    }
    catch (e_2_1) { e_2 = { error: e_2_1 }; }
    finally {
        try {
            if (aggregates_1_1 && !aggregates_1_1.done && (_b = aggregates_1.return)) _b.call(aggregates_1);
        }
        finally { if (e_2) throw e_2.error; }
    }
    if (!validate)
        throw new std.DomainError("Bug on special math function(s).");
}
exports.test_special_maths = test_special_maths;
function _Difference(x, y) {
    if (x === 0 && y === 0)
        return 0;
    else if (isNaN(x) && isNaN(y))
        return 0;
    else if (Math.abs(x - y) < Math.pow(10, -5))
        return 0;
    var diff = Math.abs(y - x);
    if ((x === 0 || y === 0) && diff < 0.00001)
        return 0;
    else
        return diff / Math.max(Math.abs(x), Math.abs(y));
}
//# sourceMappingURL=test_special_maths.js.map