"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports._Test_try_lock = exports._Test_lock = exports.test_mutexes = void 0;
var std = __importStar(require("../../index"));
var SLEEP_TIME = 50;
var READ_COUNT = 10;
function test_mutexes() {
    return __awaiter(this, void 0, void 0, function () {
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, _Test_lock(new std.Mutex())];
                case 1:
                    _a.sent();
                    return [4 /*yield*/, _Test_try_lock(new std.TimedMutex())];
                case 2:
                    _a.sent();
                    return [4 /*yield*/, _Test_lock_shared(new std.SharedMutex())];
                case 3:
                    _a.sent();
                    return [4 /*yield*/, _Test_try_lock_shared(new std.SharedTimedMutex())];
                case 4:
                    _a.sent();
                    return [2 /*return*/];
            }
        });
    });
}
exports.test_mutexes = test_mutexes;
/* ---------------------------------------------------------
    WRITE LOCK
--------------------------------------------------------- */
function _Test_lock(mtx_1) {
    return __awaiter(this, arguments, void 0, function (mtx, name) {
        var start_time, elapsed_time;
        if (name === void 0) { name = mtx.constructor.name; }
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    start_time = Date.now();
                    // LOCK FOR A SECOND
                    mtx.lock();
                    std.sleep_for(SLEEP_TIME).then(function () {
                        mtx.unlock();
                    });
                    // TRY LOCK AGAIN
                    return [4 /*yield*/, mtx.lock()];
                case 1:
                    // TRY LOCK AGAIN
                    _a.sent();
                    elapsed_time = Date.now() - start_time;
                    return [4 /*yield*/, mtx.unlock()];
                case 2:
                    _a.sent();
                    if (elapsed_time < SLEEP_TIME * 0.95)
                        throw new Error("Bug on ".concat(name, ".lock() & unlock(): it does not work in exact time."));
                    return [2 /*return*/];
            }
        });
    });
}
exports._Test_lock = _Test_lock;
function _Test_try_lock(mtx_1) {
    return __awaiter(this, arguments, void 0, function (mtx, name) {
        var start_time, ret, elapsed_time;
        if (name === void 0) { name = mtx.constructor.name; }
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, _Test_lock(mtx, name)];
                case 1:
                    _a.sent();
                    start_time = Date.now();
                    return [4 /*yield*/, mtx.try_lock_for(SLEEP_TIME)];
                case 2:
                    ret = _a.sent();
                    if (ret === false)
                        throw new Error("Bug on ".concat(name, ".try_lock_for(): it does not return exact value"));
                    return [4 /*yield*/, mtx.try_lock_for(SLEEP_TIME)];
                case 3:
                    // TRY LOCK AGAIN
                    ret = _a.sent();
                    elapsed_time = Date.now() - start_time;
                    if (ret === true)
                        throw new Error("Bug on ".concat(name, ".try_lock_for(): it does not return exact value"));
                    else if (elapsed_time < SLEEP_TIME * 0.95)
                        throw new Error("Bug on ".concat(name, ".try_lock_for(): it does not work in exact time"));
                    return [4 /*yield*/, mtx.unlock()];
                case 4:
                    _a.sent();
                    return [2 /*return*/];
            }
        });
    });
}
exports._Test_try_lock = _Test_try_lock;
/* ---------------------------------------------------------
    READ LOCK
--------------------------------------------------------- */
function _Test_lock_shared(mtx) {
    return __awaiter(this, void 0, void 0, function () {
        var read_count, i, start_time, elapsed_time, i, i;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: 
                // TEST WRITING LOCK & UNLOCK
                return [4 /*yield*/, _Test_lock(mtx)];
                case 1:
                    // TEST WRITING LOCK & UNLOCK
                    _a.sent();
                    read_count = 0;
                    for (i = 0; i < READ_COUNT; ++i) {
                        mtx.lock_shared();
                        ++read_count;
                    }
                    if (read_count !== READ_COUNT)
                        // READ LOCK CAN BE DONE SIMULTANEOUSLY
                        throw new Error("Bug on ".concat(mtx.constructor.name, ".lock_shared(): it doesn't support the simultaneous lock."));
                    start_time = Date.now();
                    std.sleep_for(SLEEP_TIME).then(function () {
                        // SLEEP FOR A SECOND AND UNLOCK ALL READINGS
                        for (var i = 0; i < READ_COUNT; ++i)
                            mtx.unlock_shared();
                    });
                    // DO WRITE LOCK; MUST BE BLOCKED
                    return [4 /*yield*/, mtx.lock()];
                case 2:
                    // DO WRITE LOCK; MUST BE BLOCKED
                    _a.sent();
                    elapsed_time = Date.now() - start_time;
                    if (elapsed_time < SLEEP_TIME * 0.95)
                        throw new Error("Bug on ".concat(mtx.constructor.name, ".lock(): it does not block writing while reading."));
                    //----
                    // WRITE FIRST, READ LATER
                    //----
                    start_time = Date.now();
                    std.sleep_for(SLEEP_TIME).then(function () {
                        // SLEEP FOR A SECOND AND UNLOCK WRITINGS
                        mtx.unlock();
                    });
                    i = 0;
                    _a.label = 3;
                case 3:
                    if (!(i < READ_COUNT)) return [3 /*break*/, 6];
                    return [4 /*yield*/, mtx.lock_shared()];
                case 4:
                    _a.sent();
                    _a.label = 5;
                case 5:
                    ++i;
                    return [3 /*break*/, 3];
                case 6:
                    // VALIDATE ELAPSED TIME
                    elapsed_time = Date.now() - start_time;
                    if (elapsed_time < SLEEP_TIME * 0.95)
                        throw new Error("Bug on ".concat(mtx.constructor.name, ".lock_shared(): it does not block reading while writing."));
                    i = 0;
                    _a.label = 7;
                case 7:
                    if (!(i < READ_COUNT)) return [3 /*break*/, 10];
                    return [4 /*yield*/, mtx.unlock_shared()];
                case 8:
                    _a.sent();
                    _a.label = 9;
                case 9:
                    ++i;
                    return [3 /*break*/, 7];
                case 10: return [2 /*return*/];
            }
        });
    });
}
function _Test_try_lock_shared(mtx) {
    return __awaiter(this, void 0, void 0, function () {
        var start_time, elapsed_time, flag, i, i, i, i;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: 
                // TEST WRITING LOCK & UNLOCK
                return [4 /*yield*/, _Test_try_lock(mtx)];
                case 1:
                    // TEST WRITING LOCK & UNLOCK
                    _a.sent();
                    return [4 /*yield*/, _Test_lock_shared(mtx)];
                case 2:
                    _a.sent();
                    //----
                    // READ SIMULTANEOUSLY
                    //----
                    start_time = Date.now();
                    i = 0;
                    _a.label = 3;
                case 3:
                    if (!(i < READ_COUNT)) return [3 /*break*/, 6];
                    return [4 /*yield*/, mtx.try_lock_shared_for(SLEEP_TIME)];
                case 4:
                    flag = _a.sent();
                    if (flag === false)
                        throw new Error("Bug on ".concat(mtx.constructor.name, ".try_lock_shared_for(): it does not return exact value."));
                    _a.label = 5;
                case 5:
                    ++i;
                    return [3 /*break*/, 3];
                case 6:
                    // VALIDATE ELAPSED TIME
                    elapsed_time = Date.now() - start_time;
                    if (elapsed_time >= SLEEP_TIME)
                        throw new Error("Bug on ".concat(mtx.constructor.name, ".try_lock_shared_for(): it does not support simultaneous lock."));
                    //----
                    // WRITE LOCK
                    //----
                    // TRY WRITE LOCK ON READING
                    start_time = Date.now();
                    return [4 /*yield*/, mtx.try_lock_for(SLEEP_TIME)];
                case 7:
                    flag = _a.sent();
                    elapsed_time = Date.now() - start_time;
                    if (flag === true)
                        throw new Error("Bug on ".concat(mtx.constructor.name, ".try_lock_for(): it does not return exact value while reading."));
                    else if (elapsed_time < SLEEP_TIME * 0.95)
                        throw new Error("Bug on ".concat(mtx.constructor.name, ".try_lock_for(): it does not block while reading."));
                    // TRY WRITE LOCK AFTER READING
                    std.sleep_for(SLEEP_TIME).then(function () {
                        for (var i = 0; i < READ_COUNT; ++i)
                            mtx.unlock_shared();
                    });
                    start_time = Date.now();
                    return [4 /*yield*/, mtx.try_lock_for(SLEEP_TIME)];
                case 8:
                    flag = _a.sent();
                    elapsed_time = Date.now() - start_time;
                    if (flag === false)
                        throw new Error("Bug on ".concat(mtx.constructor.name, ".try_lock_for(): it does not return exact value while reading."));
                    else if (elapsed_time < SLEEP_TIME * 0.95)
                        throw new Error("Bug on ".concat(mtx.constructor.name, ".try_lock_for(): it does not work in exact time."));
                    //----
                    // READ LOCK
                    //----
                    // READ LOCK ON WRITING
                    start_time = Date.now();
                    i = 0;
                    _a.label = 9;
                case 9:
                    if (!(i < READ_COUNT)) return [3 /*break*/, 12];
                    return [4 /*yield*/, mtx.try_lock_shared_for(SLEEP_TIME)];
                case 10:
                    flag = _a.sent();
                    if (flag === true)
                        throw new Error("Bug on ".concat(mtx.constructor.name, ".try_lock_shared_for(): it does not return exact value while writing."));
                    _a.label = 11;
                case 11:
                    ++i;
                    return [3 /*break*/, 9];
                case 12:
                    elapsed_time = Date.now() - start_time;
                    if (elapsed_time < SLEEP_TIME * READ_COUNT * 0.95)
                        throw new Error("Bug on ".concat(mtx.constructor.name, ".try_lock_shared_for(): it does not work in exact time."));
                    // READ LOCK AFTER WRITING
                    start_time = Date.now();
                    std.sleep_for(SLEEP_TIME).then(function () {
                        mtx.unlock();
                    });
                    i = 0;
                    _a.label = 13;
                case 13:
                    if (!(i < READ_COUNT)) return [3 /*break*/, 16];
                    return [4 /*yield*/, mtx.try_lock_shared_for(SLEEP_TIME)];
                case 14:
                    flag = _a.sent();
                    if (flag === false)
                        throw new Error("Bug on ".concat(mtx.constructor.name, ".try_lock_shared_for(): it does not return exact value after writing."));
                    _a.label = 15;
                case 15:
                    ++i;
                    return [3 /*break*/, 13];
                case 16:
                    elapsed_time = Date.now() - start_time;
                    if (elapsed_time < SLEEP_TIME * 0.95 || elapsed_time >= SLEEP_TIME * 5.0)
                        throw new Error("Bug on ".concat(mtx.constructor.name, ".try_lock_shared_for(): it does not work in exact time."));
                    i = 0;
                    _a.label = 17;
                case 17:
                    if (!(i < READ_COUNT)) return [3 /*break*/, 20];
                    return [4 /*yield*/, mtx.unlock_shared()];
                case 18:
                    _a.sent();
                    _a.label = 19;
                case 19:
                    ++i;
                    return [3 /*break*/, 17];
                case 20: return [2 /*return*/];
            }
        });
    });
}
//# sourceMappingURL=test_mutexes.js.map