"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.test_variadic_singleton = void 0;
var index_1 = __importDefault(require("../../index"));
function closure(counter, x, y, z) {
    ++counter.value;
    return x + y + z;
}
function test_variadic_singleton() {
    var variadic = new index_1.default.VariadicSingleton(closure);
    var counter = { value: 0 };
    for (var i = 0; i < 10; ++i)
        for (var x = 0; x < 3; ++x)
            for (var y = 0; y < 3; ++y)
                for (var z = 0; z < 3; ++z) {
                    var solution = variadic.get(counter, x, y, z);
                    if (solution !== x + y + z)
                        throw new Error("Bug on VariadicSingleton.get(): failed to detect the different arguments.");
                }
    if (counter.value !== 27)
        throw new Error("Bug on VariadicSingleton.get(): failed to memoize the pre-generated value.");
}
exports.test_variadic_singleton = test_variadic_singleton;
//# sourceMappingURL=test_variadic_singleton.js.map